import 'dart:math';
import 'package:intl/intl.dart';
import 'package:flutter/material.dart';
import 'package:syncfusion_flutter_charts/charts.dart';
import 'package:syncfusion_flutter_core/core.dart';

void main() {
  //Register your license here
  SyncfusionLicense.registerLicense(null);
  return runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  List<_ChartData> chartData = [];
  Random random = Random();
  final int min = 2;
  final int max = 6;

  DateTime xMinimum;

  @override
  void initState() {
    for (int i = 1; i < 29; i++) {
      chartData.add(_ChartData(
          DateTime(2019, 12, i), (min + random.nextInt(max - min)).toDouble()));
      //Found the first day of the week
      if (xMinimum == null &&
          DateFormat('EEEE').format(DateTime(2019, 12, i)) == 'Monday')
        xMinimum = DateTime(2019, 12, i);
    }
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Center(
        child: Container(
          child: SfCartesianChart(
            primaryXAxis: DateTimeAxis(
                minimum: xMinimum,
                interval: 7,
                dateFormat: DateFormat.yMEd(),
                labelIntersectAction: AxisLabelIntersectAction.multipleRows,
                intervalType: DateTimeIntervalType.days),
            series: <LineSeries<_ChartData, DateTime>>[
              LineSeries<_ChartData, DateTime>(
                dataSource: chartData,
                xValueMapper: (_ChartData sales, _) => sales.x,
                yValueMapper: (_ChartData sales, _) => sales.y,
                animationDuration: 0,
              )
            ],
          ),
        ),
      ),
    );
  }
}

class _ChartData {
  _ChartData(this.x, this.y);
  final DateTime x;
  final double y;
}
